#include <iostream>
#include <fstream>
#include <typeinfo>
#include <cstdint>
#include <sys/resource.h>
#include <vector>
#include <limits>

extern "C" {
    
    void stress(){
        std::string jsonString;
        std::getline(std::cin, jsonString);
      
	    // create a vector growing over iteration
        std::vector<std::string> dynamicVector;
        for (size_t i = 0; i < 1000; i++){
            dynamicVector.push_back(jsonString);
            size_t maxvalue = std::numeric_limits<size_t>::max();
            std::cout << "maxvalue " << maxvalue << " - i " << i << " - length: " << jsonString.length()*(i+1) << std::endl;
            
            // // print memory usage (work only in cpp not wasm)
            // struct rusage usage;
            // if (getrusage(RUSAGE_SELF, &usage) == 0) {
            //     double memoryGB = static_cast<double>(usage.ru_maxrss) / (1024 * 1024); 
            //     std::cout << "\tMemory usage: " << usage.ru_maxrss << " KB ->" << memoryGB << " GB"<< std::endl;
            // } else {
            //     std::cerr << "Failed to get memory usage information." << std::endl;
            // }
        }
        
    }
    
    int main(int argc, char *argv[]) {
        stress();
        return 0; 
    }
    
   
}
